import astropy,os,scipy
#from pyfits import getdata
#from pyfits import getheader
#from pyfits import getval
import numpy as np
from astropy.io import fits
from scipy.ndimage import gaussian_filter1d

name_filter=['g','bokr','r','z','u']

os.system('ls e*.fits > fits.lst')

filename=open('fits.lst','r')
date=next(filename)[1:5]
filename.close()

for line in open("fits.lst"):
    line=line.strip("\n")
    
    objectname=fits.getval(line,'IMAGETYP',0)
    if (objectname != 'zero') and (objectname != 'flat'):

        filter=fits.getval(line,'FILTER',0)
        print(line,objectname,filter)
        for i in range(5):
            if (filter == name_filter[i]):
                flat_name='flat_'+date+'_'+name_filter[i]+'.fits'
                flat_sky_name='flat_'+date+'_'+name_filter[i]+'_sky.fits'
            else:
                flat_name='flat_'+date+'_'+filter+'.fits'
                flat_sky_name='flat_'+date+'_'+filter+'_sky.fits'

        if(os.path.isfile(flat_sky_name)):
            flat_sky=fits.open(flat_sky_name)
        elif(os.path.isfile(flat_name)):
            flat_sky=fits.open(flat_name)

        if(os.path.isfile(flat_sky_name) or os.path.isfile(flat_name)):

            object=fits.open(line)

            for k in range(16):    

                object[k+1].data[:2048,:2016]/=flat_sky[k+1].data[:2048,:2016]

            line1=line.replace('e','p')
            object.writeto(line1[:15],clobber='Ture')
            object.close()

            flat_sky.close()
            object.close()
